<?php

namespace Drupal\parameters\Plugin;

/**
 * Interface for parameter plugins that need to take action on usage.
 */
interface UsageParameterInterface extends ParameterInterface {

  /**
   * Takes action when the parameter is being added.
   */
  public function onAddition(): void;

  /**
   * Takes action when the parameter configuration has been changed.
   */
  public function onChange(array $previous_configuration): void;

  /**
   * Takes action when the parameter is being removed.
   */
  public function onRemoval(): void;

}
